<template>
  <div>
    <v-card class="pl-6 pr-6 pb-5 pt-2">
      <v-card-title class="pb-0">
        <h1>
          <b v-if="material">{{$t('editarMaterial')}}</b>
          <b v-else>{{$t('nuevoMaterial')}}</b>
        </h1>
      </v-card-title>
      <v-form v-model="valid" ref="materialFrom" class="pb-4 pt-4">
        <v-row>
          <v-col cols="12" lg="2" md="2" sm="12">
            <v-text-field
              v-model="form.codigo"
              :rules="rules.isRequired"
              maxlength="10"
              :counter="10"
              dense
              :label="$t('codigo')"
              @keyup="uppercase"
              
            />
          </v-col>
          <v-col cols="12" lg="4" md="4" sm="12">
            <v-text-field
              v-model="form.descripcion"
              :rules="rules.isRequiredyNoSim"
              maxlength="50"
              :counter="50"
              dense
              :label="$t('descripcion')"
              @keyup="uppercase"
              @input="nonumeros"
            />
          </v-col>
          <v-col cols="12" lg="4" md="4" sm="12">
            <v-text-field
              v-model="form.marca"
              :rules="rules.isRequired"
              maxlength="50"
              :counter="50"
              dense
              :label="$t('marca')"
              @keyup="uppercase"
            />
          </v-col>
          <v-col cols="12" lg="2" md="2" sm="12">
            <v-text-field
              v-model="form.color"
              :rules="rules.isRequired"
              maxlength="50"
              :counter="50"
              dense
              :label="$t('color')"
              @keyup="uppercase"
            />
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12" lg="2" md="2" sm="12">
            <v-text-field
              v-model="form.tamanio"
              :rules="rules.isRequired"
              maxlength="50"
              :counter="50"
              dense
              :label="$t('tamanio')"
              @keyup="uppercase"
            />
          </v-col>
          <v-col cols="12" lg="3" md="3" sm="12">
            <v-menu
              v-model="menuFecha"
              :close-on-content-click="false"
            >
              <template v-slot:activator="{ on, attrs }">
                <v-text-field
                  v-model="form.fecha_registro"
                  :rules="rules.isRequired"
                  :label="$t('fechaRegistro')"
                  readonly
                  v-bind="attrs"
                  v-on="on"
                  dense
                ></v-text-field>
              </template>
              <v-date-picker
                v-model="form.fecha_registro"
                @input="menuFecha = false"
                locale="es"
                :max="(new Date(Date.now() - (new Date()).getTimezoneOffset() * 60000)).toISOString().substr(0, 10)"
              ></v-date-picker>
            </v-menu>
          </v-col>
          <v-col cols="12" lg="3" md="3" sm="12">
            <v-select
              v-model="form.unid_manejo"
              :items="unidad"
              :rules="rules.isRequired"
              dense
              :label="$t('unidManejo')"
            />
          </v-col>
          <v-col cols="12" lg="2" md="2" sm="12">
            <v-text-field
              v-model="form.cantidad"
              :rules="rules.isRequired"
              onkeyup="value=value.replace(/[^0-9^\.]+/g,'').replace(/\./g,'').replace('$#$','.').replace(/^0+/, '')"
              dense
              :label="$t('Cantidad Inicial')"
              
              
              
              
            />
          </v-col>
          <v-col cols="12" lg="2" md="2" sm="12">
            <v-text-field
              v-model="form.precio"
              :rules="rules.isRequired"
              onkeyup="value=value.replace(/[^0-9^\.]+/g,'').replace('.','$#$').replace(/\./g,'').replace('$#$','.').replace(/^0+/, '')"
              dense
              :label="$t('Precio Inicial')"
              
            />
          </v-col>
        </v-row>
      </v-form>
      <v-card-actions>
        <v-row>
          <v-btn
            color="accent"
            rounded
            @click="guardarMaterial"
          >
            {{$t('guardar')}}
          </v-btn>
          <v-btn text color="error" rounded @click="cancelarGuardar">
            {{$t('cancelar')}}
          </v-btn>
          <br/>
        </v-row>
      </v-card-actions>
    </v-card>
  </div>
</template>

<script>
import MaterialServicio from '@/store/services/MaterialServicio'

export default {
  name:'MaterialesForm',
  props: {
    material: {
      type: Object,
      required: false,
      default: null
    }
  },
  data () {
    return {
      valid: false,
      form: {
        id: '',
        codigo: '',
        descripcion: '',
        marca: '',
        color: '',
        tamanio: '',
        unid_manejo: '',
        fecha_registro: '',
        cantidad: '',
        precio: '',
        /*inputRules: [
          v => v.length >= 3 || 'Minium length is 3 characters'
        ]*/
      },
      rules: {
        isRequired: [value => !!value || this.$t('campoRequerido')],
        //inputRules: [v => v.length >= 3 || 'Minium length is 3 characters'],


        isRequiredyNoSim: [
          value => !!value || this.$t('campoRequerido'),
          v => /[^0-9+\W]/g.test(v) || this.$t('noNumerosC'),
        ],
      },

      

      isLoading: false,
      menuFecha: false,
      cropper: {},
      date: null,
      imgDefault: '',

      unidad: [
        'UNIDAD',
        'PAQUETE',
        'CAJA',
        'BIDON',
      ]
    }
  },
  methods: {
    async guardarMaterial() {
      try {
        if (this.$refs.materialFrom.validate()) {
          var response = ''
          if (!this.form.id || this.form.id === '') {
            let dataForm = new FormData()
            for (let key in this.form) {
              dataForm.append(key, this.form[key])
            }
            response = await MaterialServicio.create(dataForm)
          } else {
            response = await MaterialServicio.update(this.form.id, this.form)
          }
          this.resetData()
          this.$emit('onMaterialGuardado', response.data)

          
        }
      } catch (e) {console.log(e)
        // if (e.response.status > 300) {
        //   this.$notify({
        //     group: 'loggedIn',
        //     type: 'error',
        //     text: e.response.data.message,
        //   });
        // }
      }
    },
    cancelarGuardar() {
      this.resetData()
      this.$emit('onCancelarGuardar',  false);
    },

    uppercase() {
        this.form.codigo = this.form.codigo.toUpperCase();
        this.form.descripcion = this.form.descripcion.toUpperCase();
        this.form.marca = this.form.marca.toUpperCase();
        this.form.color = this.form.color.toUpperCase();
        this.form.tamanio = this.form.tamanio.toUpperCase();
    },

    nonumeros() {
      this.form.descripcion = this.form.descripcion.replaceAll(/[^a-zA-Z-( )'20W''50']/g, "");
      this.form.cantidad = this.form.cantidad.replaceAll(/[^e']/g, "");
    },

    noletras() {
      this.form.precio = this.form.precio.replaceAll(/[^1-9]/g, "");
      this.form.cantidad = this.form.cantidad.replaceAll(/[1-9]/g, "");
      
    },





    setData() {
      if (this.material) {
        this.form.id = this.material.id
        this.form.codigo = this.material.codigo
        this.form.descripcion = this.material.descripcion
        this.form.marca = this.material.marca
        this.form.tamanio = this.material.tamanio
        this.form.unid_manejo = this.material.unid_manejo
        this.form.color = this.material.color
        this.form.fecha_registro = this.material.fecha_registro
        this.form.cantidad = this.material.cantidad_inicial
        this.form.precio = this.material.precio_inicial
      }
    },
    resetData() {
      this.$refs.materialFrom.reset()
      this.form.id = null
    },
   
  },
  computed: {

  },
  watch: {
    computedDateFormatted() {
      this.form.year = this.computedDateFormatted
    },
    material() {
      this.setData()
    }
  },
  created() {
    this.setData()
  }
}
</script>

<style>

</style>
